public inbox for cygwin-cvs@sourceware.org
help / color / mirror / Atom feed
From: Corinna Vinschen <corinna@sourceware.org>
To: cygwin-cvs@sourceware.org
Subject: [newlib-cygwin] Cygwin: cygtls: fix context alignment
Date: Mon, 29 Aug 2022 13:21:23 +0000 (GMT)	[thread overview]
Message-ID: <20220829132123.83F353858D32@sourceware.org> (raw)

https://sourceware.org/git/gitweb.cgi?p=newlib-cygwin.git;h=dcab768cb93e59712af5818736c4de783ae2c612

commit dcab768cb93e59712af5818736c4de783ae2c612
Author: Corinna Vinschen <corinna@vinschen.de>
Date:   Mon Aug 29 15:18:53 2022 +0200

    Cygwin: cygtls: fix context alignment
    
    A hang was encountered, apparently triggered by commit 63b503916d42,
    changing tls_pathbufs from malloc'ed to HeapAlloc'ed memory.  After
    lengthy debugging it transpired that adding the heap handle to the
    tls_pathbuf struct added 8 bytes to the cygtls area, thus moving
    the "context" member by 8 bytes, too, so it was suddently unaligned.
    
    Fix this for now by changing the alignment.
    
    Fix this once and for all, by adding code to the gentls_offsets script
    to check if the alignment of the "context" member is 16 bytes.  If not,
    print a matching error message, remove the just generated file, and exit
    with error.
    
    FIXME: It would be really nice to find a way to auomate the correct
    alignment of the "context" member, but I don't see any way to use
    alignment attributes to get what we need here.
    
    Signed-off-by: Corinna Vinschen <corinna@vinschen.de>

Diff:
---
 winsup/cygwin/local_includes/cygtls.h | 7 +++++--
 winsup/cygwin/scripts/gentls_offsets  | 9 +++++++++
 2 files changed, 14 insertions(+), 2 deletions(-)

diff --git a/winsup/cygwin/local_includes/cygtls.h b/winsup/cygwin/local_includes/cygtls.h
index 018a59946..61c4cbeef 100644
--- a/winsup/cygwin/local_includes/cygtls.h
+++ b/winsup/cygwin/local_includes/cygtls.h
@@ -178,11 +178,14 @@ public: /* Do NOT remove this public: line, it's a marker for gentls_offsets. */
   siginfo_t *sigwait_info;
   HANDLE signal_arrived;
   bool will_wait_for_signal;
+#if 0
   long __align;			/* Needed to align context to 16 byte. */
+#endif
   /* context MUST be aligned to 16 byte, otherwise RtlCaptureContext fails.
      If you prepend cygtls members here, make sure context stays 16 byte
-     aligned. */
-  ucontext_t context;
+     aligned. The gentls_offsets script checks for that now and fails
+     if the alignment is wrong. */
+  ucontext_t __attribute__((__aligned__(__alignof__(long double)))) context;
   DWORD thread_id;
   siginfo_t infodata;
   struct pthread *tid;
diff --git a/winsup/cygwin/scripts/gentls_offsets b/winsup/cygwin/scripts/gentls_offsets
index 0adb702a3..040b5de6b 100755
--- a/winsup/cygwin/scripts/gentls_offsets
+++ b/winsup/cygwin/scripts/gentls_offsets
@@ -98,3 +98,12 @@ gawk -v start_offset="$start_offset" '\
     }
   }
 ' ${tmp_file} > "${output_file}"
+# Check if the `context' member is 16 bytes aligned.  Delete output_file
+# and bail out with error if not.
+MOD=$(awk '/_cygtls.context_p/{ print $3 % 16; }' "${output_file}")
+if [ $MOD -ne 0 ]
+then
+  echo "Error: _cygtls.context member is not 16 bytes aligned!"
+  rm "${output_file}"
+  exit 1
+fi

                 reply	other threads:[~2022-08-29 13:21 UTC|newest]

Thread overview: [no followups] expand[flat|nested]  mbox.gz  Atom feed

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20220829132123.83F353858D32@sourceware.org \
    --to=corinna@sourceware.org \
    --cc=cygwin-cvs@sourceware.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).